import './api.dart';

/// VK API Groups class
class Groups {
  /// API class
  API _api;

  /// Groups
  Groups(API api) {
    this._api = api;
  }

  toString() {
    return 'Groups';
  }

  /// Add address
  Future<Map> addAddress([Map<String, String> params]) async {
    return this._api.request('addAddress', {
      ...?params,
    });
  }

  /// Add callback server
  Future<Map> addCallbackServer([Map<String, String> params]) async {
    return this._api.request('addCallbackServer', {
      ...?params,
    });
  }

  /// Add link
  Future<Map> addLink([Map<String, String> params]) async {
    return this._api.request('addLink', {
      ...?params,
    });
  }

  /// Approve request
  Future<Map> approveRequest([Map<String, String> params]) async {
    return this._api.request('approveRequest', {
      ...?params,
    });
  }

  /// Ban user
  Future<Map> ban([Map<String, String> params]) async {
    return this._api.request('ban', {
      ...?params,
    });
  }

  /// Create group
  Future<Map> create([Map<String, String> params]) async {
    return this._api.request('create', {
      ...?params,
    });
  }

  /// Delete address
  Future<Map> deleteAddress([Map<String, String> params]) async {
    return this._api.request('deleteAddress', {
      ...?params,
    });
  }

  /// Delete callback server
  Future<Map> deleteCallbackServer([Map<String, String> params]) async {
    return this._api.request('deleteCallbackServer', {
      ...?params,
    });
  }

  /// Delete link
  Future<Map> deleteLink([Map<String, String> params]) async {
    return this._api.request('deleteLink', {
      ...?params,
    });
  }

  /// Disable online
  Future<Map> disableOnline([Map<String, String> params]) async {
    return this._api.request('disableOnline', {
      ...?params,
    });
  }

  /// Edit group
  Future<Map> edit([Map<String, String> params]) async {
    return this._api.request('edit', {
      ...?params,
    });
  }

  /// Edit address
  Future<Map> editAddress([Map<String, String> params]) async {
    return this._api.request('editAddress', {
      ...?params,
    });
  }

  /// Edit callback server
  Future<Map> editCallbackServer([Map<String, String> params]) async {
    return this._api.request('editCallbackServer', {
      ...?params,
    });
  }

  /// Edit link
  Future<Map> editLink([Map<String, String> params]) async {
    return this._api.request('editLink', {
      ...?params,
    });
  }

  /// Edit manager
  Future<Map> editManager([Map<String, String> params]) async {
    return this._api.request('editManager', {
      ...?params,
    });
  }

  /// Enable online
  Future<Map> enableOnline([Map<String, String> params]) async {
    return this._api.request('enableOnline', {
      ...?params,
    });
  }

  /// Get user's groups
  Future<Map> get([Map<String, String> params]) async {
    return this._api.request('get', {
      ...?params,
    });
  }

  /// Get addresses
  Future<Map> getAddresses([Map<String, String> params]) async {
    return this._api.request('getAddresses', {
      ...?params,
    });
  }

  /// Get banned users
  Future<Map> getBanned([Map<String, String> params]) async {
    return this._api.request('getBanned', {
      ...?params,
    });
  }

  /// Get group by ID
  Future<Map> getById([Map<String, String> params]) async {
    return this._api.request('getById', {
      ...?params,
    });
  }

  /// Get callback confirmation code
  Future<Map> getCallbackConfirmationCode([Map<String, String> params]) async {
    return this._api.request('getCallbackConfirmationCode', {
      ...?params,
    });
  }

  /// Get callback servers
  Future<Map> getCallbackServers([Map<String, String> params]) async {
    return this._api.request('getCallbackServers', {
      ...?params,
    });
  }

  /// Get callback settings
  Future<Map> getCallbackSettings([Map<String, String> params]) async {
    return this._api.request('getCallbackSettings', {
      ...?params,
    });
  }

  /// Get catalog
  Future<Map> getCatalog([Map<String, String> params]) async {
    return this._api.request('getCatalog', {
      ...?params,
    });
  }

  /// Get catalog info
  Future<Map> getCatalogInfo([Map<String, String> params]) async {
    return this._api.request('getCatalogInfo', {
      ...?params,
    });
  }

  /// Get invited users
  Future<Map> getInvitedUsers([Map<String, String> params]) async {
    return this._api.request('getInvitedUsers', {
      ...?params,
    });
  }

  /// Get invites
  Future<Map> getInvites([Map<String, String> params]) async {
    return this._api.request('getInvites', {
      ...?params,
    });
  }

  /// Get longpoll server
  Future<Map> getLongPollServer([Map<String, String> params]) async {
    return this._api.request('getLongPollServer', {
      ...?params,
    });
  }

  /// Get longpoll settings
  Future<Map> getLongPollSettings([Map<String, String> params]) async {
    return this._api.request('getLongPollSettings', {
      ...?params,
    });
  }

  /// Get members
  Future<Map> getMembers([Map<String, String> params]) async {
    return this._api.request('getMembers', {
      ...?params,
    });
  }

  /// Get online status
  Future<Map> getOnlineStatus([Map<String, String> params]) async {
    return this._api.request('getOnlineStatus', {
      ...?params,
    });
  }

  /// Get requests
  Future<Map> getRequests([Map<String, String> params]) async {
    return this._api.request('getRequests', {
      ...?params,
    });
  }

  /// Get settings
  Future<Map> getSettings([Map<String, String> params]) async {
    return this._api.request('getSettings', {
      ...?params,
    });
  }

  /// Get token permissions
  Future<Map> getTokenPermissions([Map<String, String> params]) async {
    return this._api.request('getTokenPermissions', {
      ...?params,
    });
  }

  /// Invite user
  Future<Map> invite([Map<String, String> params]) async {
    return this._api.request('invite', {
      ...?params,
    });
  }

  /// Is user member?
  Future<Map> isMember([Map<String, String> params]) async {
    return this._api.request('isMember', {
      ...?params,
    });
  }

  /// Join group
  Future<Map> join([Map<String, String> params]) async {
    return this._api.request('join', {
      ...?params,
    });
  }

  /// Leave group
  Future<Map> leave([Map<String, String> params]) async {
    return this._api.request('leave', {
      ...?params,
    });
  }

  /// Remove user from group
  Future<Map> removeUser([Map<String, String> params]) async {
    return this._api.request('removeUser', {
      ...?params,
    });
  }

  /// Reorder link
  Future<Map> reorderLink([Map<String, String> params]) async {
    return this._api.request('reorderLink', {
      ...?params,
    });
  }

  /// Search for group
  Future<Map> search([Map<String, String> params]) async {
    return this._api.request('search', {
      ...?params,
    });
  }

  /// Set callback settings
  Future<Map> setCallbackSettings([Map<String, String> params]) async {
    return this._api.request('setCallbackSettings', {
      ...?params,
    });
  }

  /// Set longpoll settings
  Future<Map> setLongPollSettings([Map<String, String> params]) async {
    return this._api.request('setLongPollSettings', {
      ...?params,
    });
  }

  /// Unban user
  Future<Map> unban([Map<String, String> params]) async {
    return this._api.request('unban', {
      ...?params,
    });
  }
}
