import './api.dart';

/// Utils class
class Utils {
  /// API class
  API _api;

  /// Utils
  Utils(API api) {
    this._api = api;
  }

  toString() {
    return 'Utils';
  }

  /// Check link
  Future<Map> checkLink([Map<String, String> params]) async {
    return this._api.request('utils.checkLink', {
      ...?params,
    });
  }

  /// Delete the link from last shortened links
  Future<Map> deleteFromLastShortened([Map<String, String> params]) async {
    return this._api.request('utils.deleteFromLastShortened', {
      ...?params,
    });
  }

  /// Get last shortened links
  Future<Map> getLastShortenedLinks([Map<String, String> params]) async {
    return this._api.request('utils.getLastShortenedLinks', {
      ...?params,
    });
  }

  /// Get link statistics
  Future<Map> getLinkStats([Map<String, String> params]) async {
    return this._api.request('utils.getLinkStats', {
      ...?params,
    });
  }

  /// Get server time
  Future<Map> getServerTime([Map<String, String> params]) async {
    return this._api.request('utils.getServerTime', {
      ...?params,
    });
  }

  /// Get short link
  Future<Map> getShortLink([Map<String, String> params]) async {
    return this._api.request('utils.getShortLink', {
      ...?params,
    });
  }

  /// Resolve screen name
  Future<Map> resolveScreenName([Map<String, String> params]) async {
    return this._api.request('utils.resolveScreenName', {
      ...?params,
    });
  }
}
